package com.followlast;

public class InTopost {

    private String input;
    private String output = "";
    private Stack strStack;
    int allength = 0;
    int index = 0;
    final static int ALPHABET = 100000;
    public static int[] alphabet_list = new int[ALPHABET];//标注每个字母的长度

    public InTopost(String in) {
        input = in;
        int stackSize = input.length();
        strStack = new Stack(stackSize);
    }

    public String transform() {
        char ch = ' ';

        for (int i = 0; i < input.length(); i++) {
            ch = input.charAt(i);
            if (ch == '[') {
                String index = "";
                gotOper(ch, 3);
                ++i;
                while (Util.isDigitA(input.charAt(i))) {
                    gotOper(input.charAt(i), 3);
                    i++;
                }
                gotOper(input.charAt(i), 3);

            } else if (ch == '|' || ch == '&') {
                gotOper(ch, 1);
            } else if (ch == ',') {
                gotOper(ch, 2);
            } else if (ch == '(') {
                strStack.push(ch);
            } else if (ch == ')') {
                gotParen(ch);
            } else if (ch == '*' || ch == '?' || ch == '+') {
                gotOper(ch, 3);
            } else {
                allength = 0;
                while (Util.isDigitA(ch)) {
                    allength++;
                    output = output + ch;
                    if (i < (input.length() - 1)) {
                        ch = input.charAt(++i);
                    } else {
                        ++i;
                        break;
                    }
                }
                --i;
                alphabet_list[index] = allength;
                ++index;
            }
        }
        while (!strStack.isEmpty()) {
            char temp = strStack.pop();
            output = output + temp;
        }
        return output;
    }

    public void gotParen(char ch) {
        while (!strStack.isEmpty()) {
            char chx = strStack.pop();
            if (chx == '(')
                break;
            else {
                if (chx == '[') {
                    while (chx != ']') {
                        chx = strStack.pop();
                        output = output + chx;
                    }
                } else {
                    output = output + chx;
                }
            }
        }
    }

    public void gotOper(char opThis, int prec1) {
        while (!strStack.isEmpty()) {
            char opTop = strStack.pop();
            if (opTop == '(') {
                strStack.push(opTop);
                break;
            } else {
                int prec2;
                if (opTop == '|' || opTop == '&')
                    prec2 = 1;
                else if (opTop == ',')
                    prec2 = 2;
                else
                    prec2 = 3;
                if (prec2 < prec1) {
                    strStack.push(opTop);
                    break;
                } else
                    output = output + opTop;
            }
        }
        strStack.push(opThis);
    }

    public void gotOper1(char opThis, int prec1) {
        while (!strStack.isEmpty()) {
            char opTop = strStack.pop();
            if (opTop == '(') {
                strStack.push(opTop);
                break;
            } else {
                int prec2;
                if (opTop == '|' || opTop == '&')
                    prec2 = 1;
                else if (opTop == ',')
                    prec2 = 2;
                else
                    prec2 = 3;
                if (prec2 < prec1) {
                    strStack.push(opTop);
                    break;
                } else if (opTop == '[') {
                    output = output + '[';
                    while (strStack.peek() != ']') {
                        output = output + strStack.pop();
                    }
                    output = output + ']';
                } else {

                    output = output + opTop;
                }

            }
        }
        strStack.push(opThis);
    }
}	


