package com.followlast;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;


public class Node<T extends Comparable<T>> {
	private Node<Integer> leftNode;
	private Node<Integer> rightNode;
	private int number;//字母下标
	private int position;
	private int key;
	private int layer = 0; 
	private boolean nullable;
	private boolean flexible;
	private boolean multiful;
	private boolean alphabet;//识别是否为字母表
	private boolean indicator;//识别上标［1，2］［2］
	private int flag=0;
	public ArrayList<Node<Integer>> Last=new ArrayList<Node<Integer>>();
	public ArrayList<Node<Integer>> First=new ArrayList<Node<Integer>>();
	public ArrayList<Node<Integer>> Follow=new ArrayList<Node<Integer>>();
	public ArrayList<Node<Integer>> Followlast=new ArrayList<Node<Integer>>();
	public ArrayList<Node<Integer>> getChilds() {
		return childs;
	}
	public ArrayList <Node<Integer>> childs=new ArrayList<Node<Integer>> ();
	public Node(){
		super();
	}
	public Node(char t){
		leftNode=null;
		rightNode=null;
		number = 0;
		key=t;
		setNullable(false);
		setFlexible(false);
		setMultiful(false);
		Last=null;
		First=null;
		flag=0;
		position=0;
		childs=null;
		setAlphabet(false);
		setIndicator(false);
	}
	public void setFollowlast(Node<Integer> node){
		this.Followlast.add(node);
	}
	public ArrayList<Node<Integer>>  getFollowlast(){
		return Followlast;
	}
	public void setFirst(Node<Integer> node){
		this.First.add(node);
	}
	public ArrayList<Node<Integer>>  getFirst(){
		return First;
	}
	public void setFollow(Node<Integer> node){
		this.Follow.add(node);
	}
	public ArrayList<Node<Integer>> getFollow(){
		return Follow;
	}
	public void setLast(Node<Integer> node){
		this.Last.add(node);
	}
	public ArrayList<Node<Integer>> getLast(){
		return Last;
	}
	public Node<Integer> getLeftNode() {
		return leftNode;
	}
	public void setLeftNode(Node<Integer> leftNode) {
		this.leftNode = leftNode;
	}
	public Node<Integer> getRightNode() {
		return rightNode;
	}
	public void setRightNode(Node<Integer> newRightNode) {
		this.rightNode = newRightNode;
	}

	public int getKey() {
		return key;
	}

	public void setKey(int key) {
		this.key = key;
	}

	public int getNumber() {
		return number;
	}
	public void setNumber(int number) {
		this.number = number;
	}
	public String toString(){
		return key+"";

	}
	
	public int getLayer() {
		return layer;
	}
	public void setLayer(int layer) {
		this.layer = layer;
	}
	public ArrayList<Node> dirChild(Node root) {
		ArrayList<Node> dirchild=new ArrayList<Node>();
		if (root.getLeftNode()!=null){
			dirchild.add(root.getLeftNode());	
		}
		if (root.getRightNode()!=null) {
		
			dirchild.add(root.getRightNode());	
		}
		return dirchild;
		// TODO Auto-generated method stub
		
	}
	public boolean isNullable() {
		return nullable;
	}
	public void setNullable(boolean nullable) {
		this.nullable = nullable;
	}
	public int getFlag() {
		return flag;
	}
	public void setFlag(int flag) {
		this.flag = flag;
	}
	public int getPosition() {
		return position;
	}
	public void setPosition(int position) {
		this.position = position;
	}
	public boolean isFlexible() {
		return flexible;
	}
	public void setFlexible(boolean flexible) {
		this.flexible = flexible;
	}
	public boolean isAlphabet() {
		return alphabet;
	}
	public void setAlphabet(boolean alphabet) {
		this.alphabet = alphabet;
	}
	public boolean isIndicator() {
		return indicator;
	}
	public void setIndicator(boolean indicator) {
		this.indicator = indicator;
	}
	public boolean isMultiful() {
		return multiful;
	}
	public void setMultiful(boolean multiful) {
		this.multiful = multiful;
	}


}
