package com.followlast;

public class Queue {
	private int maxSize;
	private Node[] queArray;
	private int front;
	private int rear;
	private int element;
	public Queue(int size)
	{
		maxSize=size;
		queArray=new Node[maxSize];
		front=0;
		rear=-1;
		element=0;
	}
	public void insert(Node<Integer> node)
	{
			queArray[++rear]=node;

			element++;		
	}
	public Node<Integer>  remove()
	{
	
			Node<Integer>  temp=queArray[front];
			 front++;
			 element--;
			return temp;
			
	}
	public Node<Integer>  peek()
	{
		return queArray[front];
	}
	public boolean isEmpty() 
	{
		return(element==0);
	}
	public boolean isFull() 
	{
		return (element==maxSize);	
	}
	public int length()
	{
		return element;
	}
}
