package com.followlast;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;


public class UI {
	public static ImageIcon imageSize(String st){
		 try{
			 File file=new File( st);
			 BufferedImage imagetemp= ImageIO.read(file);    
			 int width = 25; 
			 int height =26;   

			 double  scaleWidth  =  (double) width / (double)  imagetemp.getWidth(); 
			 double  scaleHeight  =  (double) height / (double)  imagetemp.getHeight(); 

			 BufferedImage  dstImage  =  new BufferedImage(width, height, imagetemp.getType()); 

			 AffineTransform  affineTransform  =  new  AffineTransform(); 
			 affineTransform.scale(scaleWidth  ,  scaleHeight); 
			 AffineTransformOp affineTransformOp = new AffineTransformOp(affineTransform,2);//
			 affineTransformOp.filter(imagetemp, dstImage); 
			 return new ImageIcon(dstImage);
			 
			  }catch(IOException e){
			  	System.out.println(e.getMessage());
			  }
		return null;	
	}

}
