package com.followlast;

import org.omg.Messaging.SYNC_WITH_TRANSPORT;

import java.util.Arrays;
import java.util.HashMap;

public class Expression1 {
    public static Node<Integer> root = null;
    //public static HashMap<Integer, Integer> index = new HashMap<Integer, Integer>();
    protected static int layer;
    public static int[] indicator;
    
    public static Record expression(String input) {
        input = preprocessRegex(input);

        Record record = new Record();
        float excTime;
        String regularString;
        String outString;
        String xxx;
        input = Util.preprocess(input.replaceAll(" ", ""));

        Udtool2.result = Udtool2.result + "------------------------------------------" + "\n";
        Udtool2.result = Udtool2.result + "--The simplified expression is" + input + ".\n";
        Expression.index = new HashMap<Integer, Integer>();
        char[] inputChar = input.toCharArray();
        indicator = new int[inputChar.length];
        BinaryTree<Character> currentTree = new BinaryTree<Character>();
        regularString = dIndicator(inputChar);

        InTopost tranString = new InTopost(regularString);
        outString = tranString.transform();
        xxx = printString(outString);
		//Udtool2.result = Udtool2.result+ "For expression "+String.valueOf(inputChar)+", the Postfix Expression is: "+xxx+"\n";

        root = currentTree.buildTree(outString);
        layer = currentTree.calcuLayer(root);
        currentTree.markNullable(root);
        // 我加的
        currentTree.markMultiful(root);
        currentTree.markFlexible(root, 1);    // 有markFlexible1在 可以注释掉这一行?
//		currentTree.inOrder(root);
        currentTree.markFlexible1(root, 1);
//		currentTree.inOrder(root);
        Conditions ce = new Conditions();
        long startTime = System.nanoTime();
        if (!ce.seekCharacter(root)) {

            Udtool2.result = Udtool2.result + "    !!! The expression is nondeterministic for WDRE." + "\n";
            Udtool2.result = Udtool2.result + "    So the expression is nondeterministic for SDRE!" + "\n";
            Udtool2.result = Udtool2.result + "------------------------------------------" + "\n";

            return record;
        }
        long endTime = System.nanoTime();
        excTime = endTime - startTime;
        record.setTime(excTime);
        record.setDeterministic(true);
        Udtool2.result = Udtool2.result + "    !The expression is deterministic." + "\n";
        Udtool2.result = Udtool2.result + "The second step to check wSNF:\n";
        if (iswSNF(root)) {
            Udtool2.result = Udtool2.result + "    ! The expression is in wSNF form." + "\n";
            Udtool2.result = Udtool2.result + "    So the expression is deterministic for SDRE." + "\n";
            Udtool2.result = Udtool2.result + "***********************************************************" + "\n";
        } else {
            Udtool2.result = Udtool2.result + "    !!! The expression is not in wSNF form." + "\n";
            Udtool2.result = Udtool2.result + "    So the expression is nondeterministic for SDRE!" + "\n";
            Udtool2.result = Udtool2.result + "***********************************************************" + "\n";
        }
        ;
        return record;
    }

    private static boolean iswSNF(Node<Integer> node) {
//        System.out.println(node.getKey() + "here1" + node.isIndicator());
        if (node.isAlphabet()) {
            return true;
        } else if (node.isIndicator()) {
            if (node.isMultiful()) {
                //System.out.println("kk");
                return iswSNF_helper(node.getLeftNode());
            } else {
                return iswSNF(node.getLeftNode());
            }
        } else {
//			return iswSNF(node.getLeftNode()) && iswSNF(node.getRightNode());
            if (node.getRightNode() != null) {
                return iswSNF(node.getLeftNode()) && iswSNF(node.getRightNode());
            } else {
                return iswSNF(node.getLeftNode());
            }
        }
    }

    private static boolean iswSNF_helper(Node<Integer> node) {
//        System.out.println(node.getKey() + "here2");
        int operator = node.getKey(); // node!=null
        if (node.isAlphabet()) {
            return true;
        } else if (operator == 124) {//|
            return iswSNF_helper(node.getLeftNode()) && iswSNF_helper(node.getRightNode());
        } else if (operator == 38) {    //&
            return !node.getLeftNode().isNullable() && !node.getRightNode().isNullable() && iswSNF_helper(node.getLeftNode()) &&
                    iswSNF_helper(node.getRightNode());
        } else if (operator == 44)//,
        {
            if (node.getLeftNode().isNullable() && node.getRightNode().isNullable()) {
//                System.out.println("aa");
                return false;
            } else if (!node.getLeftNode().isNullable() && !node.getRightNode().isNullable()) {
//                System.out.println("bb");
                return true;
            } else if (node.getLeftNode().isNullable() && !node.getRightNode().isNullable()) {
//                System.out.println("cc");
                return iswSNF(node.getRightNode());
            } else {
                return iswSNF(node.getLeftNode());
            }
        } else {
            return !node.isFlexible() && iswSNF_helper(node.getLeftNode());
        }
    }

    private static String printString(String outString) {
        String pString = "";
        char[] aa = outString.toCharArray();
        for (int i = 0; i < aa.length; i++) {
            pString = pString + (aa[i]) + " ";
            if (aa[i] == '[') {
                //System.out.println();
                pString += (indicator[((int) aa[++i]) - 48]);
                pString += ",";
                pString += (indicator[((int) aa[i]) - 48 + 1]);
            }
        }
        return pString;
    }

    private static String dIndicator(char[] inputChar) {
        StringBuilder result = new StringBuilder();
        int index = 0;
        int numLow = 0;
        int numUp = 0;
        for (int i = 0; i < inputChar.length; i++) {
            if (inputChar[i] == '[') {
                numLow = 0;
                numUp = 0;
                i++;
                index++;
                while (inputChar[i] != ',') {
                    numLow = (int) (numLow * Math.pow(10, 1)) + (Integer.parseInt(String.valueOf(inputChar[i])));
                    i++;
                    if (inputChar[i] == ']') {
                        numUp = numLow;
                        indicator[2 * (index - 1)] = numLow;
                        indicator[2 * (index - 1) + 1] = numUp;
                        result.append('[');
                        result.append(index - 1);
                        result.append(']');

                        break;
                    }
                }
                if (inputChar[i] == ',') {
                    i++;
                    while (inputChar[i] != ']') {
                        numUp = (int) (numUp * Math.pow(10, 1)) + (Integer.parseInt(String.valueOf(inputChar[i])));
                        i++;
                    }
                    result.append('[');
                    result.append(index - 1);
                    result.append(']');
                    indicator[2 * (index - 1)] = numLow;
                    indicator[2 * (index - 1) + 1] = numUp;
                }
            }
            if (inputChar[i] != ']') {

                result.append(inputChar[i]);
            }
        }
        return result.toString();
    }

    // 预处理正则 使之适配mou的只能支持[m,n](n>1)的counting
    public static String preprocessRegex(String regex) {
        regex = regex.replace(".", ",");
        regex = regex.replace(",]",",2147483647]");
        regex = regex.replace(",*]", ",2147483647]");
        regex = regex.replace("?", "[0,1]"); // 这里?没有重写为[0,1]是因为mou对[0,1]支持错误
        regex = regex.replace("+", "[1,2147483647]");
        regex = regex.replace("*", "[0,2147483647]");
        regex = regex.replace("{", "[").replace("}", "]");
        return regex;
    }

    // 反向预处理
    public static String unpreprocessRegex(String regex) {
        regex = regex.replace("[1,2147483647]", "+");
        regex = regex.replace("[0,2147483647]", "*");
        return regex;
    }

	public static void main(String[] args) {
    	String re = "a*,b+";
    	Expression.expression(re);
		Expression1.expression(re);
		System.out.println(Udtool2.result);
	}
}
