package com.followlast;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.awt.peer.SystemTrayPeer;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.print.attribute.AttributeSet;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import java.text.*;
import java.util.*;

public class Udtool {
    static JTextField text11 = new JTextField();
    static String result = "";
    private static FileDialog openDia;
    private static FileDialog saveDia;
    private static File file;
    private static Font font = new Font("", Font.BOLD, 14);
    private static Font fontR = new Font("Arial", Font.BOLD, 15);
    private static Font fontT = new Font("", 0, 15);

    public static void main(String[] args) {

        Image icon = Toolkit.getDefaultToolkit().getImage(("image/user.png"));
        final JFrame jFrame = new JFrame("Udtool Followlast");
        Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
        jFrame.setBounds(((int) dimension.getWidth() - 500) / 2, ((int) dimension.getHeight() - 300) / 2, 800, 580);
        jFrame.setResizable(false);

        jFrame.setLayout(null);
        jFrame.setLocationRelativeTo(null);
        jFrame.setIconImage(icon);
        jFrame.getContentPane().setBackground(new Color(149, 165, 166));//
        jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        final JButton button = new JButton();
        button.setBorderPainted(false);
        ImageIcon ico = new ImageIcon("image/icon.png");
        button.setBounds(715, 1, 16, 15);
        Image temp = ico.getImage().getScaledInstance(button.getWidth(), button.getHeight(), ico.getImage().SCALE_DEFAULT);
        ico = new ImageIcon(temp);
        button.setIcon(ico);
        button.setFocusPainted(true);
        button.addMouseListener(new MouseListener() {
            @Override
            public void mouseReleased(MouseEvent e) {
                ImageIcon ico = new ImageIcon("image/icon.png");
                button.setBounds(715, 1, 16, 15);
                Image temp = ico.getImage().getScaledInstance(button.getWidth(), button.getHeight(), ico.getImage().SCALE_DEFAULT);
                ico = new ImageIcon(temp);
                button.setIcon(ico);
            }

            @Override
            public void mousePressed(MouseEvent e) {
                // TODO Auto-generated method stub
            }

            @Override
            public void mouseExited(MouseEvent e) {
                ImageIcon ico = new ImageIcon("image/icon.png");
                button.setBounds(715, 1, 16, 15);
                Image temp = ico.getImage().getScaledInstance(button.getWidth(), button.getHeight(), ico.getImage().SCALE_DEFAULT);
                ico = new ImageIcon(temp);
                button.setIcon(ico);
            }

            @Override
            public void mouseEntered(MouseEvent e) {
                ImageIcon ico = new ImageIcon("image/icon2.png");
                button.setBounds(715, 1, 16, 15);
                Image temp = ico.getImage().getScaledInstance(button.getWidth(), button.getHeight(), ico.getImage().SCALE_DEFAULT);
                ico = new ImageIcon(temp);
                button.setIcon(ico);
            }

            @Override
            public void mouseClicked(MouseEvent e) {
                // TODO Auto-generated method stub

            }
        });
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                final JDialog ask = new JDialog(jFrame, "Introductions");
                ask.setLocationRelativeTo(jFrame);
                ask.setBounds(560, 200, 310, 420);
                ask.setVisible(true);
                ask.setLayout(new FlowLayout());
                JLabel label = new JLabel("Notes for RE(&) determing tool");
                JTextArea area = new JTextArea(15, 24);
                area.setText("\n" + "\n" + "1. The expression supports operators & , | * ? + ( ) and conting operators like: [0,3] [3,3] [3]. The concatenation operator , "
                        + "can not be ignored, for instance the expression ab is abnormal, and its right form may be a,b." + "\n"
                        + "2. Pay attention to use  half-width characters;" + "\n"
                        + "3. Counting operators like [1,2] and [2] are ok.Infinite greatness [3,infinite] can be expressed by [3]*. " + "\n"
                        + "4. When dealing with a text, blank lines mean the end." + "\n"
                        + "5. The syntax tree is saved as s-tree.img automatically." + "\n"
                        + "6. The expression can be (1,2) or (af&ggh) or (asgdgd＊｜798，k.l), and so on. It is case sensitive. " + "\n"
                        + "7. Abnormal expressions are illegal, and the tool will warn you or return a wrong answer. "
                );
                JButton jButton = new JButton("All known");
                jButton.setContentAreaFilled(false);
                jButton.setBorderPainted(false);
                //jButton. setForeground(new Color(0x33, 0x66, 0xcc));
                jButton.setAlignmentX(FlowLayout.RIGHT);
                jButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        ask.dispose();
                    }
                });
                area.setLineWrap(true);        //锟斤拷锟斤拷锟皆讹拷锟斤拷锟叫癸拷锟斤拷
                area.setWrapStyleWord(true);    // 锟斤拷锟斤拷锟斤拷胁锟斤拷锟斤拷止锟斤拷锟�
                ask.add(label);
                ask.add(area);
                ask.add(jButton);

            }
        });

        JLabel label0 = new JLabel("HELP?");
        label0.setBounds(600, 2, 120, 30);
        label0.setFont(fontR);
        jFrame.add(button);
        JTabbedPane tabPane = new JTabbedPane(JTabbedPane.TOP);
        jFrame.add(tabPane);
        tabPane.setBackground(new Color(149, 165, 166));
        tabPane.setBounds(10, 0, 760, 530);
        ImageIcon expre = UI.imageSize("image/exp.png");
        ImageIcon filepre = UI.imageSize("image/files.png");
        JPanel panel0 = createPanel(1);
        //指锟斤拷锟斤拷签锟斤拷锟斤拷锟斤拷签图锟疥，panel锟斤拷锟斤拷锟斤拷示锟斤拷息
        panel0.setBounds(0, 20, 600, 400);
        tabPane.addTab("Single Expression", expre, panel0, "Input Expression");
        tabPane.setFont(new Font(result, Font.BOLD, 12));
        JPanel panel1 = createPanel(2);
        //指锟斤拷锟斤拷签锟斤拷锟斤拷锟斤拷签图锟疥，panel锟斤拷锟斤拷锟斤拷示锟斤拷息
        tabPane.addTab("Batching", filepre, panel1, "Batching Test");
        openDia = new FileDialog(jFrame, "My opening", FileDialog.LOAD);
        saveDia = new FileDialog(jFrame, "My saving", FileDialog.SAVE);
        jFrame.setVisible(true);
    }

    public static JPanel createPanel(int s) {
        //锟斤拷锟斤拷一锟斤拷JPanel锟斤拷锟斤拷为锟斤拷锟届函锟斤拷锟斤拷始false
        //锟斤拷示锟斤拷锟斤拷锟斤拷双锟斤拷锟斤拷
        final Expression ex = new Expression();
        JPanel panel = new JPanel(false);

        //锟斤拷锟矫诧拷锟斤拷
        panel.setLayout(null);
        Calendar ctime = Calendar.getInstance();
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//锟斤拷锟斤拷锟斤拷锟节革拷式
        final String sDate = df.format(new Date());
        if (s == 1) {
            JLabel label11 = new JLabel("Input Expression");
            label11.setBounds(10, 30, 120, 30);
            label11.setFont(fontR);
            text11.setBounds(150, 30, 240, 30);

            JButton button11 = new JButton("Check WDRE");
            button11.setBounds(400, 30, 110, 30);

            JButton button111 = new JButton("Check SDRE");
            button111.setBounds(505, 30, 110, 30);

            JButton button12 = new JButton("Reset");
            button12.setBounds(610, 30, 90, 30);
            button12.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    text11.setText("");
                }
            });
            Color aa = new Color(119, 136, 153);


            JLabel label12 = new JLabel("Results");
            label12.setFont(fontR);
            label12.setBounds(10, 90, 100, 30);

            final JTextArea textAreaOutput;
            textAreaOutput = new JTextArea("Current time: " + sDate, 20, 83);
            textAreaOutput.setFont(fontT);
            textAreaOutput.setSelectedTextColor(Color.RED);
            textAreaOutput.setLineWrap(true);        //锟斤拷锟斤拷锟皆讹拷锟斤拷锟叫癸拷锟斤拷
            textAreaOutput.setWrapStyleWord(true);    // 锟斤拷锟斤拷锟斤拷胁锟斤拷锟斤拷止锟斤拷锟�
            //final JTextPane textPane = new JTextPane();
            //final MutableAttributeSet time = textPane.getStyledDocument().addStyle(null, null);
            // StyleConstants.setFontFamily(time, "verdana");
            //StyleConstants.setFontSize(time, 12);

            final JButton jButton13 = new JButton("Clear");
            jButton13.setBounds(300, 90, 85, 30);
            jButton13.setContentAreaFilled(false);
            jButton13.setBorderPainted(false);
            jButton13.setFont(new java.awt.Font("Dialog", 0, 12));
            jButton13.setForeground(Color.blue);
            jButton13.addMouseListener(new MouseListener() {
                @Override
                public void mouseReleased(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                }

                @Override
                public void mousePressed(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                }

                @Override
                public void mouseExited(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                }

                @Override
                public void mouseEntered(MouseEvent arg0) {
                    jButton13.setToolTipText("Clear all contents in textarea ");

                }

                @Override
                public void mouseClicked(MouseEvent arg0) {
                    // TODO Auto-generated method stub

                }
            });
            jButton13.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    textAreaOutput.setText("Current time: " + sDate);
                    //textPane.getDocument().insertString(textPane.getDocument().getLength(), "Current time:"+sDate, time);

                    textAreaOutput.setFont(fontT);
                    result = "";
                }
            });
            JButton jButton14 = new JButton("Save");
            jButton14.setBounds(380, 90, 80, 30);
            jButton14.setContentAreaFilled(false);
            jButton14.setBorderPainted(false);
            jButton14.setFont(new java.awt.Font("Dialog", 0, 12));
            jButton14.setForeground(Color.blue);
            jButton14.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String text = textAreaOutput.getText();
                    if (text.equals("Current time: " + sDate)) {
                        JOptionPane.showMessageDialog(null, "There is no result!", "Important Notification", JOptionPane.INFORMATION_MESSAGE);

                    } else {
                        saveDia.setVisible(true);
                        String dirPath = saveDia.getDirectory();
                        String fileName = saveDia.getFile();

                        if (dirPath == null || fileName == null)
                            return;
                        file = new File(dirPath, fileName);
                        try {
                            BufferedWriter bufw = new BufferedWriter(new FileWriter(file));
                            bufw.write(text);
                            bufw.close();
                        } catch (IOException ex) {
                            throw new RuntimeException("Fail for saving!");
                        }
                    }

                }
            });

            JScrollPane jsp = new JScrollPane();
            jsp.getViewport().add(textAreaOutput);
            jsp.setBounds(new Rectangle(10, 120, 450, 360));

            jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
            jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

            final JScrollPane jspp = new JScrollPane();
            JTextPane text = new JTextPane();
            setDocs("\n" + "\n" + "\n" + "\n" + "\n" + "The syntax tree of the expression,", Color.BLACK, true, 14, text);
            setDocs("\n" + "    saved as s-tree.jpg", Color.gray, true, 16, text);
            jspp.getViewport().setView(text);
            jspp.getViewport().add(text);

            jspp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
            jspp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
            jspp.setPreferredSize(new Dimension(1024, 1024));
            jspp.setBounds(new Rectangle(480, 120, 250, 360));
            jspp.getViewport().setBackground(new Color(255, 255, 255));
            result = result + "Current time: " + sDate + "\n";


            button11.addActionListener(new ActionListener() {
                                           public void actionPerformed(ActionEvent e) {
                                               textAreaOutput.setFont(fontT);
                                               if (text11.getText().trim().equals("")) {
                                                   JOptionPane.showMessageDialog(null, "Please input the expression, then click", "Important Notification", JOptionPane.INFORMATION_MESSAGE);
                                               } else {

                                                   try {
                                                       Record record = new Record();
                                                       record = Expression.expression(text11.getText());
                                                       if (record.isDeterministic()) {
                                                           result = result + "*The time cost is(ns):" + record.getTime() + "\n";
                                                       }
                                                       textAreaOutput.setText(result);
                                                       //								// the show of syntax tree
                                                       //								final TreePanel panelTree = new TreePanel(TreePanel.CHILD_ALIGN_RELATIVE);
                                                       //								    jspp.getViewport().setView(panelTree);
                                                       //								 panelTree.setPreferredSize(new Dimension(Expression.layer*200+80,Expression.layer*90+80));
                                                       //								// panelTree.setBounds(0, 20, Expression.layer*200+80,Expression.layer*90+80);
                                                       //								     panelTree.setTree(Expression.root);
                                                       //									 panelTree.setBackground(new Color( 255, 255,255));
                                                       //									 panelTree.setVisible(true);
                                                       //								  jspp.getViewport().add(panelTree);
                                                       //

                                                       final TreePanel panelTree = new TreePanel(TreePanel.CHILD_ALIGN_RELATIVE);
                                                       final JPanel saveJp = new JPanel();
                                                       saveJp.setBounds(0, 0, Expression.layer * 200 + 80, Expression.layer * 90 + 80);
                                                       saveJp.setBackground(new Color(255, 255, 255));
                                                       saveJp.setVisible(true);
                                                       jspp.getViewport().setView(saveJp);
                                                       panelTree.setPreferredSize(new Dimension(Expression.layer * 200 + 80, Expression.layer * 90 + 80));
                                                       panelTree.setTree(Expression.root);
                                                       panelTree.setBackground(new Color(255, 255, 255));
                                                       panelTree.setVisible(true);
                                                       saveJp.add(panelTree);
                                                       jspp.getViewport().add(saveJp);
                                                       savePic(saveJp);

                                                   } catch (Exception e2) {
                                                       JOptionPane.showMessageDialog(null, "Please recheck the abnormal input expression, if necessary you can click 'help'", "Abnormal expression", JOptionPane.ERROR_MESSAGE);
                                                       throw new RuntimeException("Abnormal expressions!");
                                                   }
                                               }
                                               //textArea.add(panelTree);


                                           }
                                       }
            );
            //for strong DRE
            button111.addActionListener(new ActionListener() {
                                            public void actionPerformed(ActionEvent e) {
                                                textAreaOutput.setFont(fontT);
                                                if (text11.getText().trim().equals("")) {
                                                    JOptionPane.showMessageDialog(null, "Please input the expression, then click", "Important Notification", JOptionPane.INFORMATION_MESSAGE);
                                                } else {
                                                    try {
                                                        Record record = new Record();
                                                        record = Expression1.expression(text11.getText());
                                                        textAreaOutput.setText(result);
                                                    } catch (Exception e2) {
                                                        JOptionPane.showMessageDialog(null, "Please recheck the abnormal input expression, if necessary you can click 'help'", "Abnormal expression", JOptionPane.ERROR_MESSAGE);
                                                        throw new RuntimeException("Abnormal expressions!");
                                                    }
                                                }
                                                //textArea.add(panelTree);


                                            }
                                        }
            );
            panel.add(text11);
            panel.add(label11);
            panel.add(label12);
            panel.add(jButton13);
            panel.add(jButton14);
            panel.add(button11);
            panel.add(button111);
            panel.add(button12);
            //panel.add(panel11);
            panel.add(jsp);
            panel.add(jspp);
            panel.validate();
            panel.setVisible(true);
        } else {
            ///////////////////////////////////////////////////////////////////////////////
            JLabel label21 = new JLabel("Select Process File");
            label21.setBounds(10, 30, 150, 30);
            label21.setFont(fontR);
            final JTextField text21 = new JTextField(12);
            text21.setBounds(160, 30, 250, 30);


            JButton button21 = new JButton("Browse ");
            button21.addActionListener(new ActionListener() {

                @Override
                public void actionPerformed(ActionEvent e) {
                    openDia.setVisible(true);

                    String dirPath = openDia.getDirectory();//锟斤拷取锟侥硷拷路锟斤拷
                    String fileName = openDia.getFile();//锟斤拷取锟侥硷拷锟斤拷锟斤拷

                    //System.out.println(dirPath +"++"+ fileName);

                    //锟斤拷锟斤拷锟铰凤拷锟� 锟斤拷 目录为锟斤拷 锟津返回匡拷
                    if (dirPath == null || fileName == null)
                        return;

                    if (fileName.endsWith("txt")) {
                        file = new File(dirPath, fileName);
                        text21.setText(dirPath + fileName);
                    } else {
                        text21.setText("Please choose .txt file");
                    }
                }
            });


            final JTextArea textAreaOutput;
            textAreaOutput = new JTextArea("Current time: " + sDate + "\n", 10, 43);
            textAreaOutput.setFont(fontT);
            textAreaOutput.setSelectedTextColor(Color.RED);
            textAreaOutput.setLineWrap(true);        //锟斤拷锟斤拷锟皆讹拷锟斤拷锟叫癸拷锟斤拷
            textAreaOutput.setWrapStyleWord(true);            // 锟斤拷锟斤拷锟斤拷胁锟斤拷锟斤拷止锟斤拷锟�
            textAreaOutput.setBounds(10, 130, 680, 220);

            button21.setBounds(430, 30, 90, 30);
            JButton button22 = new JButton("Check");
            button22.setBounds(540, 30, 90, 30);
            button22.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (text21.getText().trim().equals("")) {
                        JOptionPane.showMessageDialog(null, "Please input the expression, then click", "Important Notification", JOptionPane.INFORMATION_MESSAGE);
                    } else {
                        try {
                            float alltime = 0;
                            textAreaOutput.setText("Current time: " + sDate + "\n" + "    processing..." + "\n");
                            textAreaOutput.paintImmediately(textAreaOutput.getBounds());
                            BufferedReader bufr = new BufferedReader(new FileReader(file));
                            String line = null;
                            Record record = new Record();
                            textAreaOutput.setText("Current time: " + sDate + "\n");
                            int count = 0;
                            int ex = 0;
                            line = bufr.readLine();
                            while (line != null) {
                                try {
                                    //System.out.println(line);
                                    record = Expression.expression(line);
                                } catch (Exception e2) {
                                    // TODO: handle exception
                                    JOptionPane.showMessageDialog(null, "Please recheck the abnormal input expression, if necessary you can click 'help'", "Abnormal expression", JOptionPane.ERROR_MESSAGE);
                                    throw new RuntimeException("Fail for reading");

                                }
                                count++;
                                if (record.isDeterministic()) {
                                    ex++;
                                    alltime = alltime + record.getTime();
                                    textAreaOutput.append("     Expression -" + count + "- is deterministic." + "\n");

                                    //System.out.println("     Expression -"+count+"- is deterministic.");
                                } else {
                                    textAreaOutput.append("     !!!Expression -" + count + "- is not deterministic." + "\n");
                                }

                                line = bufr.readLine();

                            }
                            textAreaOutput.append("All numbers of expressions " + count + " , but the amount of deterministic expressions is:" + ex + ".\n");
                            textAreaOutput.append("*The time cost is(ns):" + alltime + ".\n");
                            bufr.close();
                        } catch (IOException ex) {
                            JOptionPane.showMessageDialog(null, "Please recheck the abnormal input expression, if necessary you can click 'help'", "Abnormal expression", JOptionPane.ERROR_MESSAGE);
                            throw new RuntimeException("Fail for reading");

                        }


                    }
                }
            });
            JButton button23 = new JButton("Reset");
            button23.setBounds(650, 30, 90, 30);
            button23.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    text21.setText("");
                }
            });

            JPanel panel21 = new JPanel() {
                public void paintComponent(Graphics g) {
                    super.paintComponent(g);
                    g.setColor(Color.black);
                    g.drawLine(0, 255, getWidth(), 255);
                }
            };

            panel21.setBounds(0, 85, 800, 1);
            panel21.setBackground(new Color(189, 195, 199));
            panel21.setVisible(true);

            JLabel label22 = new JLabel("Reaults");
            label22.setBounds(10, 95, 100, 30);
            label22.setFont(fontR);
            final JButton jButton23 = new JButton("Clear");
            jButton23.setBounds(550, 100, 85, 30);
            jButton23.setContentAreaFilled(false);
            jButton23.setBorderPainted(false);
            jButton23.setFont(new java.awt.Font("Dialog", 0, 12));
            jButton23.setForeground(Color.blue);
            jButton23.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    textAreaOutput.setText("Current time:" + sDate);
                    textAreaOutput.setFont(fontT);
                    result = "";
                }
            });
            jButton23.addMouseListener(new MouseListener() {
                @Override
                public void mouseReleased(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                }

                @Override
                public void mousePressed(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                }

                @Override
                public void mouseExited(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                }

                @Override
                public void mouseEntered(MouseEvent arg0) {
                    jButton23.setToolTipText("Clear all results.");

                }

                @Override
                public void mouseClicked(MouseEvent arg0) {
                    // TODO Auto-generated method stub

                }
            });
            JButton jButton24 = new JButton("Save");
            jButton24.setBounds(650, 100, 80, 30);
            jButton24.setContentAreaFilled(false);
            jButton24.setBorderPainted(false);
            jButton24.setFont(new java.awt.Font("Dialog", 0, 12));
            jButton24.setForeground(Color.blue);
            jButton24.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String text = textAreaOutput.getText();
                    if (text.equals("Current time:" + sDate)) {
                        JOptionPane.showMessageDialog(null, "No results.", "Important Notification", JOptionPane.INFORMATION_MESSAGE);

                    } else {
                        saveDia.setVisible(true);
                        String dirPath = saveDia.getDirectory();
                        String fileName = saveDia.getFile();

                        if (dirPath == null || fileName == null)
                            return;
                        file = new File(dirPath, fileName);
                        try {
                            BufferedWriter bufw = new BufferedWriter(new FileWriter(file));
                            bufw.write(text);
                            bufw.close();
                        } catch (IOException ex) {
                            throw new RuntimeException("Fail for saving");
                        }
                    }

                }
            });
            JScrollPane jsp = new JScrollPane();
            jsp.getViewport().add(textAreaOutput);
            jsp.setBounds(new Rectangle(10, 130, 720, 350));

            jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
            jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            panel.add(text21);
            panel.add(label21);
            panel.add(label22);
            panel.add(button21);
            panel.add(button22);
            panel.add(button23);
            panel.add(jButton23);
            panel.add(jButton24);
            panel.add(panel21);
            panel.add(jsp);
        }

        return panel;
    }

    public static void savePic(JPanel jp) {
        //jp.setVisible(true);
        //		//创建缓冲图片对象
        BufferedImage img = new BufferedImage(
                jp.getWidth(), jp.getHeight(), BufferedImage.TYPE_INT_RGB);
        //		//得到图形对象
        Graphics2D g2d = img.createGraphics();
        //		//将窗口内容面板输出到图形对象中
        jp.paintAll(g2d);
        //保存为图片
        File f = new File("s-tree.jpg");
        try {
            ImageIO.write(img, "jpg", f);
        } catch (IOException e) {
            e.printStackTrace();
        }
        //释放图形对象
        g2d.dispose();
    }


    public static void insert(String str, SimpleAttributeSet attrSet, JTextPane textPane) {
        Document doc = textPane.getDocument();
        str = "\n" + str;
        try {
            doc.insertString(doc.getLength(), str, (javax.swing.text.AttributeSet) attrSet);
        } catch (BadLocationException e) {
            System.out.println("BadLocationException:   " + e);
        }
    }

    public static void setDocs(String str, Color col, boolean bold, int fontSize, JTextPane textPane) {
        SimpleAttributeSet attrSet = new SimpleAttributeSet();
        StyleConstants.setForeground(attrSet, col);
        //颜色   
        if (bold == true) {
            StyleConstants.setBold(attrSet, true);
        }//字体类型   
        StyleConstants.setFontSize(attrSet, fontSize);
        //字体大小   
        insert(str, attrSet, textPane);
    }
}







